
generic

  with procedure Swap(S1,S2: in out Scalar) is <>;
  with procedure Sub(S1: in Scalar; S2: in out Scalar) is <>;
  with procedure Assign(R: in Flt; S: in out Scalar) is <>;
  with function MaxNorm(S: Scalar) return Radius is <>;

package Bisect.PSign is --- meant for polynomials

  generic
    with function FltF(X: in Flt) return Flt;
  procedure FindSigns(X1,X2: in out Flt; Y1,Y2: out Flt);     -- may not find sign change

  generic
    with function FltF(X: in Flt) return Flt;
    with function F(X: Scalar) return Flt;
  procedure RoughRoot(WMin,WMax: in Flt; W: in out Scalar; Err: in out Radius); -- FindSigns and then FindZero

end Bisect.PSign;
