
package body Bisect is

  procedure FindZero(XN,XP: in out Scalar; Err: in out Radius) is
    --- notice that (XP+XN)/2 could become XP or XN
    MaxCount: constant Natural := 4; -- max number of consecutive equal F-values
    Eps: constant Radius := Err;
    Count: Natural := 0;
    Y: Flt;
    YSave: Flt := Zero;
    X: Scalar;
  begin
    for N in 1 .. NFind loop
      Sum(XP,XN,X);
      Mult(Half,X);  -- X := (XP+XN)/2
      Y := F(X);
      exit when abs(Y)<=Eps;
      if Y=YSave then
        Count := Count+1;
        exit when Count=MaxCount;
      else
        Count := 0;
        YSave := Y;
      end if;
      if Y>Zero then Copy(X,XP); else Copy(X,XN); end if;
    end loop;
    Err := abs(Y);
  end FindZero;

end Bisect;
