package Integer_Types is

  subtype Parity is Integer range 0 .. 1;
  subtype OneTwo is Integer range 1 .. 2;
  subtype OneTwoThree is Integer range 1 .. 3;
  subtype MinusOneZeroOne is Integer range -1 .. 1;

  type Int_Vec is array(Integer range <>) of Integer;
  type Int_Mat is array(Integer range <>, Integer range <>) of Integer;
  type ParPair is array(OneTwo) of Parity;

  subtype LInt is Long_Long_Integer;
  subtype LNat is LInt range 0 .. LInt'Last;
  subtype LPos is LInt range 1 .. LInt'Last;

  --- NOTE: declaring "subtype LInt is Integer_Types.LInt"
  --- in two other packages can cause visibility problems in gnat

end Integer_Types;
