with Ints, Ada.Text_IO;
use Ints, Ada.Text_IO;

pragma Elaborate_All (Ints);

generic

  type Scalar is private;
--  with procedure Put(F: in File_Type; S: in Scalar; Decimal: in Boolean := False) is <>;
--  with procedure Get(F: in File_Type; S: in out Scalar; Decimal: in Boolean := False) is <>;

package MultiScalars is

  type Vector2 is array(OneTwo) of Scalar;
  type Vector3 is array(OneTwoThree) of Scalar;
  type Matrix2 is array(OneTwo,OneTwo) of Scalar;
  type Matrix3 is array(OneTwoThree,OneTwoThree) of Scalar;

--  procedure Put(F: in File_Type; V: in Vector3; Decimal: in Boolean := False);
--  procedure Get(F: in File_Type; V: in out Vector3; Decimal: in Boolean := False);

end MultiScalars;
