with Flts, Flt_Vectors;
use Flts, Flt_Vectors;

pragma Elaborate_All (Flt_Vectors);

package CpWeights is

  subtype FltVec is Flt_Vectors.Vector;

  function CpWeight(WFac,WPow: Radius; I: Natural) return Radius;
  function CpWeight(WFac,WPow: Radius; Last: Positive) return FltVec;
  function InvCpWeight(WFac,WPow: Radius; I: Natural) return Radius;
  function InvCpWeight(WFac,WPow: Radius; Last: Positive) return FltVec;

end CpWeights;
