with Ints, Strings;
use Ints, Strings;

pragma Elaborate_All (Ints,Strings);

package body Params is

  procedure Show(N: in String; P: in Param) is
  begin
    Show0(N & "        Prefix: " & P.Prefix);
    Show1(N & "           Map:",P.Map);
    Show1(N & "          DegX:",P.DegX);
    Show1(N & "          DegY:",P.DegY);
    Show1(N & "          LDeg:",P.LDeg);
    Show1(N & "          WFac:",P.WFac);
    Show1(N & "          EllR:",P.EllR);
    Show1(N & "          RadX:",P.RadX);
    Show1(N & "            NN:",P.NN);
    Show1(N & "            RR:",P.RR);
    Show1(N & "           Ref:",P.Ref);
    Show1(N & "          Symm: ",P.Symm);
    Show1(N & "  Mat_PackSize:",P.Mat_PackSize);
    Show1(N & "Contr_PackSize:",P.Contr_PackSize);
  end Show;

  function IndexOf(S: String) return Natural is
    Not_Found: exception;
  begin
    for I in PList'Range loop
      if LeftMatch(PList(I).Prefix,S)=4 then return I; end if;
    end loop;
    raise Not_Found;
    return 0;
  end IndexOf;

end Params;
